"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const internals_1 = require("../internals");
const internals_2 = require("../internals");
const size_1 = require("./size");
function filter(fn, map) {
    var nextSet = map;
    var immutable = core_1.isImmutable(map._owner) && (nextSet = internals_1.cloneAsMutable(map), true);
    var { _keyMap: keyMap, _sortedValues: sortedValues, } = nextSet;
    var it = internals_2.iterate(map);
    var current;
    var index = 0, remaining = size_1.size(map);
    while (!(current = it.next()).done) {
        var entry = current.value;
        if (!fn(entry.value, entry.key, index++)) {
            remaining--;
            internals_2.unsetItem(entry.key, keyMap, sortedValues);
        }
    }
    if (remaining <= 0) {
        return map;
    }
    if (immutable) {
        return internals_1.refreeze(nextSet);
    }
    map._keyMap = keyMap;
    map._sortedValues = sortedValues;
    return map;
}
exports.filter = filter;
;

//# sourceMappingURL=filter.js.map
