"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const curry_1 = require("@typed/curry");
const red_black_tree_1 = require("@collectable/red-black-tree");
const core_1 = require("@collectable/core");
const internals_1 = require("../internals");
const newObject = (map) => ({});
const unwrapShallow = curry_1.curry3(unwrapMap)(false);
const unwrapDeep = curry_1.curry3(core_1.preventCircularRefs)(newObject, curry_1.curry3(unwrapMap)(true));
function toArray(map) {
    return Array.from(map);
}
exports.toArray = toArray;
function toNativeMap(map) {
    return new Map(internals_1.iteratePairs(map));
}
exports.toNativeMap = toNativeMap;
function unwrap(deep, map) {
    return deep ? unwrapDeep(map) : unwrapShallow(map, newObject(map));
}
exports.unwrap = unwrap;
function unwrapMap(deep, map, target) {
    var it = red_black_tree_1.keys(map._sortedValues);
    var current;
    while (!(current = it.next()).done) {
        var entry = current.value;
        target[entry.key] = deep ? core_1.unwrapAny(entry.value) : entry.value;
    }
    return target;
}

//# sourceMappingURL=unwrap.js.map
