"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const red_black_tree_1 = require("@collectable/red-black-tree");
function iterate(map) {
    return red_black_tree_1.keys(map._sortedValues);
}
exports.iterate = iterate;
function toKey(item) {
    return item.key;
}
function toValue(item) {
    return item.value;
}
function toPair(item) {
    return [item.key, item.value];
}
function iterateKeys(map) {
    return new core_1.MappableIterator(red_black_tree_1.keys(map._sortedValues), toKey);
}
exports.iterateKeys = iterateKeys;
function iterateValues(map) {
    return new core_1.MappableIterator(red_black_tree_1.keys(map._sortedValues), toValue);
}
exports.iterateValues = iterateValues;
function iteratePairs(map) {
    return new core_1.MappableIterator(red_black_tree_1.keys(map._sortedValues), toPair);
}
exports.iteratePairs = iteratePairs;

//# sourceMappingURL=iterate.js.map
