import { CollectionTypeInfo, ComparatorFn, KeyedSelectorFn } from '@collectable/core';
import { RedBlackTree, HashMap } from './named-externals';
import { SortedMap, Entry } from './types';
export declare class SortedMapImpl<K, V, U> implements SortedMap<K, V> {
    _owner: number;
    _group: number;
    _keyMap: HashMap<K, Entry<K, V, U>>;
    _sortedValues: RedBlackTree<Entry<K, V, U>, null>;
    _compare: ComparatorFn<Entry<K, V, U>>;
    _select: KeyedSelectorFn<K, V, U> | undefined;
    readonly '@@type': CollectionTypeInfo;
    constructor(_owner: number, _group: number, _keyMap: HashMap<K, Entry<K, V, U>>, _sortedValues: RedBlackTree<Entry<K, V, U>, null>, _compare: ComparatorFn<Entry<K, V, U>>, _select: KeyedSelectorFn<K, V, U> | undefined);
    [Symbol.iterator](): IterableIterator<[K, V]>;
}
export declare function isSortedMap<K, V, U>(arg: any): arg is SortedMapImpl<K, V, U>;
export declare function cloneSortedMap<K, V, U>(mutable: boolean, set: SortedMapImpl<K, V, U>, clear?: boolean): SortedMapImpl<K, V, U>;
export declare function cloneAsImmutable<K, V, U>(set: SortedMapImpl<K, V, U>): SortedMapImpl<K, V, U>;
export declare function cloneAsMutable<K, V, U>(set: SortedMapImpl<K, V, U>): SortedMapImpl<K, V, U>;
export declare function refreeze<K, V, U>(set: SortedMapImpl<K, V, U>): SortedMapImpl<K, V, U>;
export declare function createSet<K, V, U>(mutable: boolean, values: [K, V][] | Iterable<[K, V]>, compare?: ComparatorFn<Entry<K, V, U>>, select?: KeyedSelectorFn<K, V, U>): SortedMapImpl<K, V, U>;
export declare function extractTree<K, V, U>(set: SortedMap<K, V>): RedBlackTree<Entry<K, V, U>, null>;
export declare function extractMap<K, V, U>(set: SortedMap<K, V>): HashMap<K, Entry<K, V, U>>;
export declare function emptySet<K, V>(mutable: boolean, compare?: ComparatorFn<Entry<K, V, any>>): SortedMapImpl<K, V, undefined>;
export declare function emptySet<K, V, U>(mutable: boolean, compare?: ComparatorFn<Entry<K, V, U>>, select?: KeyedSelectorFn<K, V, U>): SortedMapImpl<K, V, U>;
